##########################
The :mod:`gen.lib` Module
##########################

Contents:

.. automodule:: gen.lib

*****************************
Base objects
*****************************

BaseObject
====================================
.. automodule:: gen.lib.baseobj
.. autoclass:: gen.lib.baseobj.BaseObject
   :members:
   :undoc-members:
   :show-inheritance:

RefBase
====================================
.. automodule:: gen.lib.refbase
.. autoclass:: RefBase
   :members:
   :undoc-members:
   :show-inheritance:

PrivacyBase
====================================
.. automodule:: gen.lib.privacybase
.. autoclass:: PrivacyBase
   :members:
   :undoc-members:
   :show-inheritance:


SourceBase
====================================
.. automodule:: gen.lib.srcbase
.. autoclass:: SourceBase
   :members:
   :undoc-members:
   :show-inheritance:


NoteBase
====================================
.. automodule:: gen.lib.notebase
.. autoclass:: NoteBase
   :members:
   :undoc-members:
   :show-inheritance:

MediaBase
====================================
.. automodule:: gen.lib.mediabase
.. autoclass:: MediaBase
   :members:
   :undoc-members:
   :show-inheritance:

PlaceBase
====================================
.. automodule:: gen.lib.placebase
.. autoclass:: PlaceBase
   :members:
   :undoc-members:
   :show-inheritance:


LocationBase
====================================
.. automodule:: gen.lib.locationbase
.. autoclass:: LocationBase
   :members:
   :undoc-members:
   :show-inheritance:


AddressBase
====================================
.. automodule:: gen.lib.addressbase
.. autoclass:: AddressBase
   :members:
   :undoc-members:
   :show-inheritance:


AttributeBase
====================================
.. automodule:: gen.lib.attrbase
.. autoclass:: AttributeBase
   :members:
   :undoc-members:
   :show-inheritance:

DateBase
====================================
.. automodule:: gen.lib.datebase
.. autoclass:: DateBase
   :members:
   :undoc-members:
   :show-inheritance:

UrlBase
====================================
.. automodule:: gen.lib.urlbase
.. autoclass:: UrlBase
   :members:
   :undoc-members:
   :show-inheritance:

LdsOrdBase
====================================
.. automodule:: gen.lib.ldsordbase
.. autoclass:: LdsOrdBase
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Primary objects
*****************************

BasicPrimaryObject
====================================
.. automodule:: gen.lib.primaryobj
.. autoclass:: BasicPrimaryObject
   :members:
   :undoc-members:
   :show-inheritance:

PrimaryObject
====================================
.. autoclass:: PrimaryObject
   :members:
   :undoc-members:
   :show-inheritance:

Person
====================================
.. automodule:: gen.lib.person
.. autoclass:: Person
   :members:
   :undoc-members:
   :show-inheritance:


Family
====================================
.. automodule:: gen.lib.family
.. autoclass:: Family
   :members:
   :undoc-members:
   :show-inheritance:


Event
====================================
.. automodule:: gen.lib.event
.. autoclass:: Event
   :members:
   :undoc-members:
   :show-inheritance:

Place
====================================
.. automodule:: gen.lib.place
.. autoclass:: Place
   :members:
   :undoc-members:
   :show-inheritance:


Source
====================================
.. automodule:: gen.lib.src
.. autoclass:: Source
   :members:
   :undoc-members:
   :show-inheritance:


Media Object
====================================
.. automodule:: gen.lib.mediaobj
.. autoclass:: MediaObject
   :members:
   :undoc-members:
   :show-inheritance:


Repository
====================================
.. automodule:: gen.lib.repo
.. autoclass:: Repository
   :members:
   :undoc-members:
   :show-inheritance:

Note
====================================
.. automodule:: gen.lib.note
.. autoclass:: Note
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Secondary objects
*****************************

Secondary Object
====================================
.. automodule:: gen.lib.secondaryobj
.. autoclass:: SecondaryObject
   :members:
   :undoc-members:
   :show-inheritance:


Address
====================================
.. automodule:: gen.lib.address
.. autoclass:: Address
   :members:
   :undoc-members:
   :show-inheritance:

Location
====================================
.. automodule:: gen.lib.location
.. autoclass:: Location
   :members:
   :undoc-members:
   :show-inheritance:

Attribute
====================================
.. automodule:: gen.lib.attribute
.. autoclass:: Attribute
   :members:
   :undoc-members:
   :show-inheritance:

LdsOrd
====================================
.. automodule:: gen.lib.ldsord
.. autoclass:: LdsOrd
   :members:
   :undoc-members:
   :show-inheritance:

Name
====================================
.. automodule:: gen.lib.name
.. autoclass:: Name
   :members:
   :undoc-members:
   :show-inheritance:

Url
====================================
.. automodule:: gen.lib.url
.. autoclass:: Url
   :members:
   :undoc-members:
   :show-inheritance:


*****************************
Reference objects
*****************************

PersonRef
====================================
.. automodule:: gen.lib.personref
.. autoclass:: PersonRef
   :members:
   :undoc-members:
   :show-inheritance:

ChildRef
====================================
.. automodule:: gen.lib.childref
.. autoclass:: ChildRef
   :members:
   :undoc-members:
   :show-inheritance:

EventRef
====================================
.. automodule:: gen.lib.eventref
.. autoclass:: EventRef
   :members:
   :undoc-members:
   :show-inheritance:

MediaRef
====================================
.. automodule:: gen.lib.mediaref
.. autoclass:: MediaRef
   :members:
   :undoc-members:
   :show-inheritance:

SourceRef
====================================
.. automodule:: gen.lib.srcref
.. autoclass:: SourceRef
   :members:
   :undoc-members:
   :show-inheritance:

RepoRef
====================================
.. automodule:: gen.lib.reporef
.. autoclass:: RepoRef
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Date objects
*****************************
.. automodule:: gen.lib.date

Date
====================================
.. autoclass:: Date
   :members:
   :undoc-members:
   :show-inheritance:

Span
====================================
.. autoclass:: Span
   :members:
   :undoc-members:
   :show-inheritance:

DateError
====================================
.. autoexception:: DateError

*****************************
Text objects
*****************************

StyledTextTag
===================
.. automodule:: gen.lib.styledtexttag
.. autoclass:: StyledTextTag
   :members:
   :undoc-members:
   :show-inheritance:

StyledText
===========
.. automodule:: gen.lib.styledtext
.. autoclass:: StyledText
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Meta data
*****************************

GenderStats
============

.. automodule:: gen.lib.genderstats
.. autoclass:: GenderStats
   :members:
   :undoc-members:
   :show-inheritance:

Researcher
===========
.. automodule:: gen.lib.researcher
.. autoclass:: Researcher
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Type classes
*****************************
.. automodule:: gen.lib.grampstype
.. autoclass:: GrampsTypeMeta
   :members:
   :undoc-members:
   :show-inheritance:

GrampsType
===========
.. autoclass:: GrampsType
   :members:
   :undoc-members:
   :show-inheritance:

NameType
===========
.. automodule:: gen.lib.nametype
   :members:
   :undoc-members:
   :show-inheritance:

AttributeType
=============
.. automodule:: gen.lib.attrtype
   :members:
   :undoc-members:
   :show-inheritance:

UrlType
========
.. automodule:: gen.lib.urltype
   :members:
   :undoc-members:
   :show-inheritance:

ChildRefType
=============
.. automodule:: gen.lib.childreftype
   :members:
   :undoc-members:
   :show-inheritance:

RepositoryType
==============
.. automodule:: gen.lib.repotype
   :members:
   :undoc-members:
   :show-inheritance:

EventType
===========
.. automodule:: gen.lib.eventtype
.. autoclass:: EventType
   :members:
   :undoc-members:
   :show-inheritance:

FamilyRelType
=============
.. automodule:: gen.lib.familyreltype
   :members:
   :undoc-members:
   :show-inheritance:

SourceMediaType
================
.. automodule:: gen.lib.srcmediatype
   :members:
   :undoc-members:
   :show-inheritance:

EventRoleType
==============
.. automodule:: gen.lib.eventroletype
   :members:
   :undoc-members:
   :show-inheritance:

MarkerType
==========
.. automodule:: gen.lib.markertype
   :members:
   :undoc-members:
   :show-inheritance:

NoteType
=========
.. automodule:: gen.lib.notetype
   :members:
   :undoc-members:
   :show-inheritance:

StyledTextTagType
==================
.. automodule:: gen.lib.styledtexttagtype
   :members:
   :undoc-members:
   :show-inheritance:


